export class Action extends HTMLElement {
  userRecordId = "";
  objectId = "";
  softrAppId = "";
  payload = {};
  base = "";

  get targetList() {
    return this.getAttribute("targetList");
  }

  set targetList(value) {
    return this.setAttribute("targetList", value);
  }

  get actionName() {
    return this.getAttribute("actionName");
  }

  set actionName(value) {
    return this.setAttribute("actionName", value);
  }

  constructor() {
    super();
  }

  connectedCallback() {
    // Set the variables
    this.userRecordId = window.logged_in_user.record_id;
    this.softrAppId = document.querySelector(".content").dataset.appid;
    this.objectId = `${this.targetList}:${this.softrAppId}:${this.actionName}`;
    this.base = window[`${this.targetList}`].baseId;

    this.payload = {
      userRecordId: this.userRecordId,
      softrAppId: this.softrAppId,
      objectId: this.objectId,
      base: this.base,
    };

    // make the action connected call to fetch the {actionName}Records and the countRecords{actionName} to show the correct starting position for the list

    const apiURL = `https://xejw-c6td-wkd1.f2.xano.io/api:-D49NGOp:v1/Action-Connected`;

    const payloadString = JSON.stringify(this.payload);
    const component = `{"component":${payloadString}}`;

    fetch(apiURL, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
      },
      body: component,
    })
      .then((response) => response.json())
      .then((data) => {
        window[`${this.targetList}`].likedRecords = data.likedRecords;
        window[`${this.targetList}`].countRecordLikers = data.countRecordLikers;
      });

    // Add hash change event listener to the window

    window.addEventListener(
      "hashchange",
      function () {
        //if (fromList !== this.id) return;

        //// handle clicks on Softr list buttons (no click event is fired!) ///

        if (fromList === "" && thirdPartyList === "") {
          /////I AM HERE //////
          document
            .querySelectorAll(
              "a[href='" + window.location.hash + "'].MuiButtonBase-root"
            )
            ?.forEach(function (element) {
              let elem = element.closest('div[category="List"]');
              if (!elem) return;

              fromList = elem.id;
              thirdPartyList = element;
              window.iteration = 1;

              if (!elem.id) {
                fromList = "external";
              }

              card = element
                .closest(".list-item-wrapper")
                .closest(".MuiGrid-root");
            });
        }

        let hash = window.location.hash;
        let action;
        let record;

        if (hash.includes("=")) {
          action = hash.split("=")[0].slice(1);
          record = hash.split("=")[1];
        }

        if (hash.includes("&")) {
          toList = record.split("&")[1];
          record = record.split("&")[0];
        }
      }.bind(this)
    );
  }
}
