export class Listdetails extends HTMLElement {
  layouts = {
    v1: `<style>

  .split-screen {
    display: grid;
    box-sizing: border-box;
    container-type: inline-size;
  }
  
  .split-screen__half {
    flex: 1;
    max-height: 100vh;
    max-width: 100%;
    overflow-y: auto;
    overflow-x: hidden
  }
  
  ::slotted(img) {
  max-width: 100%;
  }
  
  ::slotted(div) {
  padding: 6%;
  max-width: 100%;
  }

  @container (max-width: 1199px) {
    
  }
  
  @container (max-width: 991px) {
    
  }

  @container (max-width: 767px) {
    .split-screen__half {
    flex-direction: column;
  }
  }
  
  @container (max-width: 575px) {
    .split-screen__half {
      flex-direction: column;
    }
  }
  
  </style>
  <section id="">
  <div class="split-screen">
  
  <div class="split-screen__half"><slot name="left"></slot></div>
  
  <div class="split-screen__half"><slot name="right"></slot></div>
  </div>
  </section>`,
    v2: `<style>

  /* ".inherited-styles-for-exported-element" is a generated class for the inherited styles of the exported element, feel free to rename it. */

  * {
    box-sizing: border-box;
  }
  
  section {
    display: block;
    position: relative;
  }
  
  ::-webkit-input-placeholder {
    color: inherit;
    opacity: .54;
  }
  
  ::-webkit-file-upload-button {
    appearance: button;
    font-family: inherit;
    font-size: inherit;
    font-weight: inherit;
    line-height: inherit;
  }
  
  section>* {
    position: relative;
  }
  
  h1 {
    color: inherit;
    font-family: Roboto, sans-serif;
    font-size: 2.25rem;
    line-height: 1.2;
  }
  
  h1, p {
    padding: 0;
  }
  
  .u-section-1 {
    min-height: 522px;
  }
  
  @media (max-width: 1199px) {
    .u-section-1 {
      min-height: 429px;
    }
  }
  
  @media (max-width: 991px) {
    .u-section-1 {
      min-height: 329px;
    }
  }
  
  @media (max-width: 767px) {
    .u-section-1 {
      min-height: 511px;
    }
  }
  
  @media (max-width: 575px) {
    .u-section-1 {
      min-height: 359px;
    }
  }
  
  .u-btn, .u-text-default {
    align-self: flex-start;
    display: table;
  }
  
  .u-btn {
    border: 0 none transparent;
    cursor: pointer;
    font-family: inherit;
    font-style: initial;
    font-weight: inherit;
    line-height: inherit;
    outline: 0;
    text-align: center;
    text-decoration: none;
    user-select: none;
    vertical-align: middle;
    white-space: nowrap;
  }
  
  .u-text-default {
    width: fit-content;
  }
  
  .u-image {
    background-repeat: no-repeat;
    background-size: cover;
    object-fit: cover;
    vertical-align: middle;
  }
  
  .u-container-layout {
    flex: 1 1 0;
    max-width: 100%;
    position: relative;
    transition-duration: inherit;
    -ms-overflow-style: none; /* IE and Edge */
    scrollbar-width: none; /* Firefox */
  }

  .u-conainer-layout::-webkit-scrollbar {
    display: none;
  }
  
  .u-container-layout>* {
    position: relative;
  }
  
  .u-valign-middle {
    display: flex;
    flex-direction: column;
  }
  
  .u-valign-middle>* {
    flex-shrink: 0;
  }
  
  .u-valign-middle {
    justify-content: center;
  }
  
  .u-layout-row {
    display: flex;
    flex: 1 1 auto;
  }
  
  .u-layout-row>* {
    max-height: 100%;
  }
  
  .u-layout-row {
    flex-direction: row;
    flex-wrap: wrap;
    max-width: 100%;
    min-height: fit-content;
  }
  
  .u-layout-cell {
    background-clip: padding-box;
    background-origin: padding-box;
    display: flex;
    position: relative;
    overflow-y: auto;
    max-height: 100vh;
    -ms-overflow-style: none; /* IE and Edge */
    scrollbar-width: none; /* Firefox */
  }

  .u-layout-cell::-webkit-scrollbar {
    display: none;
  }
  
  .u-group {
    display: flex;
  }
  
  .inherited-styles-for-exported-element {
    color: #111;
    font-family: "Open Sans", sans-serif;
    font-size: 1rem;
    line-height: 1.6;
  }
  
  .u-align-center {
    text-align: center;
  }
  
  .u-text {
    overflow-wrap: break-word;
  }
  
  .u-grey-5, .u-image {
    color: #111;
  }
  
  .u-grey-5 {
    background-color: #f2f2f2;
  }
  
  a:hover {
    outline: 0;
  }
  
  .u-clearfix::after {
    clear: both;
    content: "";
    display: table;
  }
  
  h1:not(.u-title) {
    font-size: 3rem;
    font-weight: 400;
    line-height: 1.1;
  }
  
  h1:not(.u-title), p:not(.u-text-variant) {
    margin-bottom: 20px;
    margin-top: 20px;
  }
  
  @media (max-width: 575px) {
    h1:not(.u-title) {
      font-size: 1.875rem;
    }
  }
  
  .u-section-1 .u-layout-wrap-1 {
    margin-bottom: 0;
    margin-top: 0;
  }
      
  .u-section-1 .u-container-layout-1 {
    padding: 0;
  }
  
  .u-section-1 .u-layout-cell-2 {
    min-height: 522px;
  }
  
  .u-section-1 .u-container-layout-2 {
    padding: 0;
  }
  
  .u-section-1 .u-group-1 {
    height: 100vh;
    margin-bottom: 0;
    margin-top: 0;
    min-height: 522px;
  }
  
  .u-section-1 .u-container-layout-3 {
    padding: 30px 50px;
    overflow-y: auto;
  }
  
  .u-section-1 .u-text-1 {
    font-weight: 700;
    margin: 0 auto;
  }
  
  .u-section-1 .u-text-2 {
    font-size: 1.25rem;
    font-weight: 300;
    margin: 20px 0 0;
  }
  
  .u-section-1 .u-btn-1 {
    background-image: none;
    font-size: 1.125rem;
    height: 50px;
    letter-spacing: 2px;
    margin: 30px auto 0;
    padding: 11px 24px 11px 23px;
    text-transform: uppercase;
  }
  
  @media (max-width: 1199px) {
  
    .u-section-1 .u-image-1,   .u-section-1 .u-layout-cell-2 {
      min-height: 100vh;
    }
  
    .u-section-1 .u-group-1 {
      min-height: 100vh;
    }
  }
  
  @media (max-width: 991px) {
    .u-section-1 .u-image-1 {
      min-height: 100vh;
    }
  
    .u-section-1 .u-layout-cell-2 {
      min-height: 100vh;
    }
  
    .u-section-1 .u-container-layout-3 {
      padding-left: 30px;
      padding-right: 30px;
    }
  }
  
  @media (max-width: 767px) {
    .u-section-1 .u-image-1 {
      min-height: 411px;
    }
  
    .u-section-1 .u-container-layout-3 {
      padding-left: 10px;
      padding-right: 10px;
    }
  }
  
  @media (max-width: 575px) {
    .u-section-1 .u-image-1 {
      min-height: 259px;
    }
  }
  
  .u-btn:hover {
    text-decoration: none;
  }
  
  .u-btn:active {
    background-image: none;
    outline: 0;
  }
  
  .u-text-default:empty {
    display: block;
    width: 15px;
  }
  
  .u-layout-row>.u-size-36 {
    flex: 0 0 60%;
    max-width: 60%;
    min-width: 60%;
  }
  
  .u-layout-row>.u-size-24 {
    flex: 0 0 40%;
    max-width: 40%;
    min-width: 40%;
    height: 100vh;
  }
  
  .u-group .u-container-layout>* {
    position: relative;
  }
  
  .u-container-style:not([class*=u-align-]) {
    text-align: left;
  }
  
  .u-btn:focus {
    outline: 5px auto -webkit-focus-ring-color;
    outline-offset: -2px;
  }
  
  .u-layout-cell.u-image:not(.u-hover-box) {
   
  }
  
  @media (min-width: 576px) and (max-width: 767px) {
    .u-layout-wrap:not(.u-layout-custom-sm) .u-layout-row>* {
      min-width: 100%;
    }
  }
  
  @media (max-width: 575px) {
    .u-layout-wrap:not(.u-layout-custom-xs) .u-layout-row>* {
      min-width: 100%;
    }
  }
  
  .u-expanded-width {
    margin-left: 0 !important;
    margin-right: 0 !important;
    width: 100% !important;
  }
  
  .u-radius-50 {
    border-radius: 50px !important;
  }
  
  ::slotted(a) {
    background-color: #db545a !important;
    color: #fff !important;
  }
  
  @media (min-width: 576px) and (max-width: 767px) {
    .u-layout-wrap:not(.u-layout-custom-sm) .u-layout {
      margin-left: 0 !important;
      margin-right: 0 !important;
    }
  }
  
  @media (max-width: 575px) {
    .u-layout-wrap:not(.u-layout-custom-xs) .u-layout {
      margin-left: 0 !important;
      margin-right: 0 !important;
    }
  }
  
  ::slotted(a):hover {
    background-color: #d63b42 !important;
    color: #fff !important;
  }
  
  @media (min-width: 576px) and (max-width: 767px) {
    .u-layout-wrap:not(.u-layout-custom-sm) .u-layout .u-layout-cell {
      border-left-color: initial !important;
      border-left-style: initial !important;
      border-left-width: 0 !important;
      border-right-color: initial !important;
      border-right-style: initial !important;
      border-right-width: 0 !important;
    }
  }
  
  @media (max-width: 575px) {
    .u-layout-wrap:not(.u-layout-custom-xs) .u-layout .u-layout-cell {
      border-left-color: initial !important;
      border-left-style: initial !important;
      border-left-width: 0 !important;
      border-right-color: initial !important;
      border-right-style: initial !important;
      border-right-width: 0 !important;
    }
  }
  
  ::slotted(img) {
    min-width: 100%;
    max-width: 100%;
    object-fit: contain;
    margin: 0;
    padding: 0;
    overflow-y: auto;
    -ms-overflow-style: none; /* IE and Edge */
    scrollbar-width: none; /* Firefox */
  }
  
  ::slotted(a) {
   text-decoration: none;
   color: white;
  }
  </style>
    
  <section class="u-clearfix u-section-1" id="sec-b580">
  <div class="u-clearfix u-expanded-width u-layout-wrap u-layout-wrap-1">
    <div class="u-layout">
      <div class="u-layout-row">
        <div class="u-container-style u-image u-layout-cell u-size-36 u-image-1">
          <div class="u-container-layout u-container-layout-1"><slot name="left"></slot></div>
        </div>
        <div class="u-container-style u-layout-cell u-size-24 u-layout-cell-2">
          <div class="u-container-layout u-container-layout-2">
            <div class="u-align-center u-container-style u-expanded-width u-grey-5 u-group u-group-1">
              <div class="u-container-layout u-valign-middle u-container-layout-3">
              <slot name="right"></slot>
                <h1 class="u-text u-text-default u-text-1" name="right"><slot name="title"></slot></h1>
                <p class="u-text u-text-2"><slot name="paragraph"></slot></p>
                <a href="" class="u-btn u-btn-round u-button-style u-color-scheme-summer-time u-color-style-multicolor-1 u-palette-2-base u-radius-50 u-btn-1"><slot name="link"></slot></a>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</section>`,
  };

  dataFetched = [];
  searchFetched = [];
  originalHTML = "";
  softrAppId = "";
  origin = "";

  get type() {
    return this.getAttribute("type");
  }

  get mode() {
    return this.getAttribute("mode");
  }

  get source() {
    return this.getAttribute("source")?.toLowerCase();
  }
  get api() {
    return this.getAttribute("api");
  }

  get record() {
    return this.getAttribute("record");
  }

  set record(val) {
    if (!this.getAttribute("record")) {
      this.setAttribute("record", val);
    }
  }

  get name() {
    return this.getAttribute("name");
  }

  set name(val) {
    if (!this.getAttribute("name")) {
      this.setAttribute("name", val);
    }
  }

  get default() {
    return this.getAttribute("default");
  }

  variant = ``;
  async setVariant(type) {
    const apiURL = `https://xejw-c6td-wkd1.f2.xano.io/api:-D49NGOp/templates/${type}`;

    await fetch(apiURL, {
      method: "GET",
      headers: {
        "Content-Type": "application/json",
      },
    })
      .then((response) => response.json())
      .then((data) => {
        const string = `${data.template}`;
        this.variant = string.replaceAll("\u00A0", "");
      });
  }

  constructor() {
    super();
    this.hidden = true; ////HERE/////
    const shadowRoot = this.attachShadow({ mode: "open" });
    const template = document.createElement("template");
    if (this.mode === "list" || this.mode === "list-rendered") {
      template.innerHTML = `${window.templateHTML[this.type]}`;
      shadowRoot.appendChild(template.content.cloneNode(true));
    } else {
      this.setVariant(this.type).then((response) => {
        if (this.variant) {
          template.innerHTML = `${this.variant}`;
          shadowRoot.appendChild(template.content.cloneNode(true));
        }

        if (!this.variant) {
          template.innerHTML = `${this.layouts.v1}`;
          shadowRoot.appendChild(template.content.cloneNode(true));
        }
      });
    }

    if (!document.querySelector(".content")?.dataset.appid) return;

    this.softrAppId = document.querySelector(".content").dataset.appid;

    this.origin = window.origin;

    this.originalHTML = this.innerHTML;

    window.addEventListener(
      "hashchange",
      function () {
        let hash = window.location.hash;
        if (hash.startsWith("#recordId=")) {
          let id = hash.split("=")[1];
          this.setAttribute("record", id);
        }
      }.bind(this)
    );
  }

  render(html) {
    this.innerHTML = ``;
    this.innerHTML = `${html}`;
  }

  connectedCallback() {
    this.innerHTML = ``;
    this.hidden = false;
    this.innerHTML = `<p>Getting info....</p>`;

    //// Experimental to implement client side rendering for lists

    if (this.mode === "list-rendered" || this.mode === "list") {
      this.render(this.originalHTML);
      return;
    }

    const childNodes = this.childNodes;
    const htmlArray = [];

    // Iterate over the nodes in the NamedNodeMap
    for (let i = 0; i < childNodes.length; i++) {
      const node = childNodes[i];
      if (node.nodeName === "#text") continue;
      const attributesArray = [];
      [...node.attributes].forEach((attr) => {
        const nodeName = attr.nodeName;
        const nodeValue = attr.nodeValue;
        attributesArray.push({ [nodeName]: nodeValue });
      });

      const slot = attributesArray.find((el) =>
        el.hasOwnProperty("slot")
      )?.slot;
      const field = attributesArray.find((el) =>
        el.hasOwnProperty("field")
      )?.field;
      const src = attributesArray.find((el) => el.hasOwnProperty("src"))?.src;
      const nodeClass = attributesArray.find((el) =>
        el.hasOwnProperty("class")
      )?.class;
      const nodeId = attributesArray.find((el) => el.hasOwnProperty("id"))?.id;
      const href = attributesArray.find((el) =>
        el.hasOwnProperty("href")
      )?.href;

      let htmlString = "";

      if (field) {
        if (node.localName === "img") {
          htmlString = `<${node.localName} slot="${slot}" field="${field}" src="{{${field}}}">`;
        } else if (node.localName === "input") {
          htmlString = "";
        } else {
          htmlString = `<${node.localName} slot="${slot}" field="${field}">{{${field}}}</${node.localName}>`;
        }
      }

      if (!field) {
        if (node.localName === "img") {
          htmlString = `<${node.localName} slot="${slot}" src="${src}">`;
        } else if (node.localName === "input") {
          htmlString = "";
        } else {
          htmlString = `<${node.localName} slot="${slot}">${node.innerHTML}</${node.localName}>`;
        }
      }

      htmlArray.push({
        tag: node.localName,
        value: node.nodeValue,
        innerText: node.innerText,
        parentElement: node.parentElement.tagName,
        innerHTML: node.innerHTML,
        attributes: attributesArray,
        field: field,
        slot: slot,
        src: src,
        class: nodeClass,
        id: nodeId,
        href: href,
        htmlString: htmlString,
      });
    }

    const componentAttributes = [];
    [...this.attributes].forEach((attr) => {
      componentAttributes.push({ [attr.nodeName]: attr.nodeValue });
    });
    const base = componentAttributes.find((el) =>
      el.hasOwnProperty("base")
    )?.base;
    const table = componentAttributes.find((el) =>
      el.hasOwnProperty("table")
    )?.table;

    const searchParams = new URLSearchParams(window.location.search);

    let recordId = "";

    if (this.default) {
      recordId = this.default;
    }

    if (this.record) {
      recordId = this.record;
    } else {
      for (const [key, value] of searchParams) {
        if (key === "recordId") {
          recordId = value;
          this.setAttribute("record", value);
        }
      }
    }

    htmlArray.unshift({
      componentName: this.tagName,
      componentAttributes: componentAttributes,
      softrAppId: this.softrAppId,
    });

    let elementsString = "";

    htmlArray.forEach((el) => {
      if (el.htmlString) {
        elementsString
          ? (elementsString = elementsString + ", " + el.htmlString)
          : (elementsString = el.htmlString);
      }
    });

    const elements = elementsString.split(", ");

    let fieldsString = "";

    htmlArray.forEach((el) => {
      if (el.componentName) return;
      const fieldValue = el.field ? el.field : "none";

      fieldsString
        ? (fieldsString = fieldsString + ", " + fieldValue)
        : (fieldsString = fieldValue);
    });

    const fields = fieldsString.split(", ");

    let tagsString = "";

    htmlArray.forEach((el) => {
      tagsString
        ? (tagsString = tagsString + ", " + el.tag)
        : (tagsString = el.tag);
    });

    const tags = tagsString?.split(", ");

    const string = JSON.stringify(this.originalHTML);

    function findUniqueSubstrings(string, substringFormat) {
      const substrings = [];
      let startIndex = 0;
      while (startIndex < string.length) {
        const start = string.indexOf(substringFormat, startIndex);
        if (start === -1) {
          break;
        }
        let end = start + substringFormat.length;
        while (string[end] !== "}") {
          end++;
        }
        end++; // include the closing curly brace
        end++; // include the closing curly brace
        substrings.push(string.substring(start, end));
        startIndex = end;
      }
      return [...new Set(substrings)];
    }

    const placeholders = findUniqueSubstrings(string, "{{");

    /* experimental passing data from list item into the payload dataFetched?.recordId.fields*/
    const data = "details";

    const fieldNames = placeholders.map((placeholder) =>
      placeholder.replace("}}", "").replace("{{", "")
    );

    const payload = {
      softrAppId: this.softrAppId,
      base: base,
      table: table,
      recordId: recordId,
      record: recordId,
      elements: elements,
      fields: fieldNames,
      tags: tags,
      innerHTML: this.originalHTML,
      originalHTML: this.originalHTML,
      placeholders: placeholders,
      data: data,
      source: this.source,
      api: this.api,
      fieldNames: fieldNames,
    };

    ////FROM HERE/////

    const payloadString = JSON.stringify(payload);
    const component = `{"component":${payloadString}}`;
    let apiURL = `https://xejw-c6td-wkd1.f2.xano.io/api:-D49NGOp/no-code-render`;

    if (this.source === "xano") {
      apiURL = `https://xejw-c6td-wkd1.f2.xano.io/api:-D49NGOp/No-Code-List`;
    }

    fetch(apiURL, {
      method: "POST",
      headers: {
        "Content-Type": "application/json",
      },
      body: component,
    })
      .then((response) => response.json())
      .then((data) => {
        let records = data;

        if (this.source !== "xano") {
          this.render(data.html);
          if (!window.nocodedetails) {
            window.nocodedetails = [];
            window.nocodedetails.unshift(...data.record);
          } else {
            window.nocodedetails.unshift(...data.record);
          }
        }

        if (this.source === "xano") {
          let output = "";
          this.dataFetched = [] = [...records];
          records.forEach((record) => {
            const dog = payload.originalHTML;

            let renderedDog = dog;

            payload.placeholders.forEach((placeholder) => {
              const fieldName = placeholder.replace("}}", "").replace("{{", "");
              let value = record.fields[fieldName];

              value = value?.url ?? value;

              value = value?.[0]?.url ?? value;

              renderedDog = renderedDog.replaceAll(
                `${placeholder}`,
                `${value}`
              );
            });

            const targetObject = this.dataFetched.find(
              (obj) => obj.fields.id === record.fields.id
            );
            const updatedObject = Object.assign({}, targetObject, {
              renderedHTML: renderedDog,
            });

            this.dataFetched = this.dataFetched.map((obj) =>
              obj === targetObject ? updatedObject : obj
            );

            this.searchFetched = [...this.dataFetched];
          });

          output = this.searchFetched.filter(
            (object) => object.fields.id.toString() === payload.recordId
          );

          output[0].source = "xano";
          output[0].api = this.api;
          output[0].record = this.record;
          if (!window.nocodedetails) {
            window.nocodedetails = [];
            window.nocodedetails.unshift(...output);
          } else {
            window.nocodedetails.unshift(...output);
          }
          this.render(output[0].renderedHTML);
        }
      });
  }

  static get observedAttributes() {
    return ["record"];
  }

  attributeChangedCallback(name, oldValue, newValue) {
    if (name === "record") {
      if (this.mode === "list" || this.mode === "list-rendered") return;
      this.record = newValue;

      if (this.source === "xano") {
        let output = this.searchFetched?.filter(
          (object) => object.fields.id.toString() === this.record
        );
        this.render(output[0]?.renderedHTML);
      }

      if (this.source !== "xano") {
        //this.connectedCallback();

        return;
      }
    }
  }
}
